#ifndef _MEXT_H_
#define _MEXT_H_

// trieda pre pracu s OGL rozsireniami
class mExt {
public:
 mExt();
 virtual ~mExt();

 // inicializacia rozsireni
 int Ext_init();

 // multitexturovana kocka
 void MultiTCube(GLuint T1,GLuint T2,GLfloat size);

 // pomerne realne vyzerajuca voda
 int water_init(void);
 void start_prepare_water_texture(GLuint w,GLuint h);
 void continue_prepare_water_texture(void);
 void end_prepare_water_texture(void);
 void render_water(GLfloat ctime);

 // parametre orezavacich rovnic pre odraz a prechod lucov
 double reflect_clip_equation[4],refract_clip_equation[4];
private:
 // nahrada klasickej funkcie glTextCoord
 PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB;
 // urcenie texturovacej jednotky, ktora prijme info o texture
 PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;

 // pocet texturovacich jednotiek Texel-Pipelines
 GLint maxTexelUnits;

 // funkcie pre Register combiners rozsirenie
 PFNGLCOMBINERPARAMETERFVNVPROC glCombinerParameterfvNV;
 PFNGLCOMBINERPARAMETERINVPROC  glCombinerParameteriNV;
 PFNGLCOMBINERINPUTNVPROC       glCombinerInputNV;
 PFNGLCOMBINEROUTPUTNVPROC      glCombinerOutputNV;
 PFNGLFINALCOMBINERINPUTNVPROC  glFinalCombinerInputNV;

 // identifikatory reflexnej a refrakcnej textury
 GLuint reflect_tex,refract_tex,combine_tex;

 // sirka a vyska okna
 GLuint scr_w,scr_h;

 // pre ulozenie pohladovej matice
 GLfloat modelview_mat[16];

 // pocitadlo prirastku casu
 GLfloat k;

 // vektory pre ulozenie texturovacich suradnic
 GLfloat plane_s[4];
 GLfloat plane_t[4];
 GLfloat plane_r[4];
 GLfloat plane_q[4];

 // 4-prvkovy vektor
 GLfloat v[4];
};

/*
  tento kod vznikol po uprave zverejneneho kodu autora:

  Alexander Zaprjagaev
  frustum@frustum.tomsk.ru
  http://frustum.tomsk.ru
*/

#endif
