#ifndef _MFIRE_H_
#define _MFIRE_H_

#include "m3Dmath.h"

typedef struct {
 GLuint N;          // pocet castic v systeme
 GLfloat *xyz;      // zoznam poloh jednotlivych castic
 GLfloat *speed;    // zoznam rychlosti jednotlivych castic
 GLfloat *time;     // zoznam "dlzky zivota" jednotlivych castic 

 m3Dvector s_pos;   // poloha systemu
 GLfloat s_time;    // "dlzka zivota" castic systemu
 GLfloat s_speed;   // rychlost castic systemu
 GLfloat s_radius;  // polomer castic systemu

 GLuint texture_id; // identifikator textury castic systemu

 m3Dvector color;   // farba castic systemu
} particle_system;

// trieda premennych a funkcii pre pracu s ohnom
class mFire {
public:
 mFire();          // konstruktor
 virtual ~mFire(); // destruktor

 int create(GLuint N,GLfloat px,GLfloat py,GLfloat pz,
            GLfloat speed,GLfloat time,GLfloat r,
            GLuint tid);                                     // vytvorenie systemu
 void setcolor(GLfloat c1,GLfloat c2,GLfloat c3,GLfloat c4); // farba systemu
 void update(GLfloat f1,GLfloat f2,GLfloat f3,GLfloat tadd); // "zivot systemu"
 void render(void);                                          // vykreslenie systemu
 void resettime(void);                                       // reset casu "zivota" systemu
private:
 GLuint ta,tb; // pomocne premenne

 particle_system *p_system; // system castic

 GLfloat *xyz,*speed; // pre "zivot systemu"
 m3Dvector s,f;       // pre "zivot systemu"

 GLfloat mvmatrix[16]; // pre maticu - spravne natocenie ohna
 m3Dvector mx,my;     // pre maticu

 GLfloat p_color[4]; // farba castice

 float noise(float a); // nahodny pohyb jednotlivych castic

 GLfloat sp,ti; // speed, time - potrebne pre resettime
};

/*
  pri priprave tohto kodu som sa inspiroval zverejnenym kodom autora:

  Alexander Zaprjagaev
  frustum@frustum.tomsk.ru
  http://frustum.tomsk.ru
*/

#endif
