// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>

// funkcie pre pracu s fontom
#include "lib/glTexFont.h"

// .h subor
#include "mText.h"

// konstruktor *************************************************************
mText::mText()
{
 mystring=mybuf;

 TextColor[0]=1.0f; TextColor[1]=1.0f; TextColor[2]=1.0f; TextColor[3]=1.0f;
 FontSize=10;
}

// destruktor **************************************************************
mText::~mText()
{

}

// inicializacia vypisovania OpenGL textu **********************************
int mText::text_initialize(void)
{
 // nahratie fontu
 if (!fontLoad("data/font.tga")) {
  fprintf(stderr,"Chyba nahratia OpenGL fontu!\n");
  return(1);
 }

 return(0);
}

// zacatie vypisu textu ****************************************************
void mText::OpenDrawString(void)
{
 // ulozenie atributov osvetlenia, testu hlbky a texturovania
 glPushAttrib(GL_LIGHTING_BIT|GL_DEPTH_BUFFER_BIT|GL_TEXTURE_BIT);
 glDisable(GL_LIGHTING);   // vypnutie osvetlenia
 glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
 glDisable(GL_TEXTURE_2D); // vypnutie texturovania

 glMatrixMode(GL_PROJECTION); // reset projekcnej matice
 glPushMatrix();
 glLoadIdentity();
 glMatrixMode(GL_MODELVIEW);  // reset pohladovej matice
 glPushMatrix();
 glLoadIdentity();
}

// vypis textu *************************************************************
void mText::DrawString(GLfloat x,GLfloat y)
{
 fontColor(TextColor[0],TextColor[1],TextColor[2]); // farba textu
 fontSize(FontSize);                                // velkost textu
 fontDrawString((int) x,(int) y,mystring);          // vypis textu

 /*
 fontSize(10);
 fontShadow();
 fontShadowColor(0.5,0.5,0.5);
 fontColor(1,0,0);
 fontDrawString(0,500,"OpenGL Extensions:");
 fontRegion(10,500,10*50,10*10);
 fontDrawString(-1,-1,glExten);

 fontGradient();
 fontGradientColor(1,1,1);
 */
}

// ukoncenie vypisu textu **************************************************
void mText::CloseDrawString(void)
{
 glPopMatrix();               // pohladova matica
 glMatrixMode(GL_PROJECTION);
 glPopMatrix();               // projekcna matica
 glMatrixMode(GL_MODELVIEW);  // aktualna musi byt vzdy pohladova matica

 glPopAttrib(); // vyber ulozenych atributov

 glColor4f(1.0f,1.0f,1.0f,1.0f); // aktualna farba bude biela - iba korekcia
}

// nastavenie farby textu **************************************************
void mText::SetTextColor(GLfloat a,GLfloat b,GLfloat c)
{
 TextColor[0]=a; TextColor[1]=b; TextColor[2]=c;
}

// nastavenie velkosti textu ***********************************************
void mText::SetFontSize(GLuint a)
{
 FontSize=a;
}
